Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 1200)
@@ -4789,156 +4750,82 @@
     m_baseLayerParameterSetCompatibilityFlag[i] = false;
   }
-  for ( Int i = 0; i < MAX_NUM_VIDEO_SIGNAL_INFO; i++ )
-  {
-    m_videoSignalInfo          [i] = NULL;     
-  }
-
   m_vpsVuiBspHrdPresentFlag = false; 
-  m_vpsVuiBspHrdParameters  = NULL;
-}
-
-TComVPSVUI::~TComVPSVUI()
-{
-  for ( Int i = 0; i < MAX_NUM_VIDEO_SIGNAL_INFO; i++ )
-  {
-    if (m_videoSignalInfo[ i ] != NULL )      delete m_videoSignalInfo[ i ];    
-    m_videoSignalInfo    [ i ] = NULL; 
-  }
-
-  if ( m_vpsVuiBspHrdParameters ) delete m_vpsVuiBspHrdParameters;
-  m_vpsVuiBspHrdParameters = NULL; 
-}
-
-Void TComVPSVUI::inferVpsVui( Bool encoderFlag )
-{
-  // inference of syntax elements that differ from default inference (as done in constructor), when VPS VUI is not present
-  if (!encoderFlag )
-  {
-    setCrossLayerIrapAlignedFlag( false ); 
-  }
-  else
-  {
-    assert( !getCrossLayerIrapAlignedFlag() ); 
-  }
-}
-
-Void TComRepFormat::inferChromaAndBitDepth( TComRepFormat* prevRepFormat, Bool encoderFlag )
-{
-  if ( !encoderFlag )
-  {
+}
+
+Void TComRepFormat::inferChromaAndBitDepth( const TComRepFormat* prevRepFormat )
+{
     setChromaAndBitDepthVpsPresentFlag( prevRepFormat->getChromaAndBitDepthVpsPresentFlag() );
     setSeparateColourPlaneVpsFlag     ( prevRepFormat->getSeparateColourPlaneVpsFlag     () );
     setBitDepthVpsLumaMinus8          ( prevRepFormat->getBitDepthVpsLumaMinus8          () );
     setBitDepthVpsChromaMinus8        ( prevRepFormat->getBitDepthVpsChromaMinus8        () );
-  }
-  else
-  {
+}
+
+Void TComRepFormat::checkInferChromaAndBitDepth( const TComRepFormat* prevRepFormat ) const 
+{
     assert( getChromaAndBitDepthVpsPresentFlag() == prevRepFormat->getChromaAndBitDepthVpsPresentFlag() );
     assert( getSeparateColourPlaneVpsFlag     () == prevRepFormat->getSeparateColourPlaneVpsFlag     () );
     assert( getBitDepthVpsLumaMinus8          () == prevRepFormat->getBitDepthVpsLumaMinus8          () );
     assert( getBitDepthVpsChromaMinus8        () == prevRepFormat->getBitDepthVpsChromaMinus8        () );
-  }
-}
-
-
-
-TComVpsVuiBspHrdParameters::~TComVpsVuiBspHrdParameters()
-{
-  delete[] m_cprmsAddPresentFlag; 
-  delete[] m_numSubLayerHrdMinus1; 
-  delete[] m_hrdParameters; 
-
-  for (Int h = 0; h < m_numOls; h++)
-  {
-    if ( h > 0 )
-    {    
-      for (Int i = 0; i < getNumSignalledPartitioningSchemes(h)+1; i++)
-      {
-        for (Int t = 0; t < m_vps->getMaxSubLayersInLayerSetMinus1( m_vps->olsIdxToLsIdx(h) ) + 1; t++)
-        {        
-          for ( Int j = 0; j <= getNumBspSchedulesMinus1(h,i,j);j++ )
-          {
-            delete[] m_bspHrdIdx  [h][i][t][j]; 
-            delete[] m_bspSchedIdx[h][i][t][j];
-          }
-        }
-        delete[] m_numBspSchedulesMinus1[h][i];
-      }
-    }
-
-    for (Int j = 0; j <= getNumSignalledPartitioningSchemes(h ) + 1; j++ )
-    {
-      for (Int k = 0; k <= getNumPartitionsInSchemeMinus1(h,j); k++ )
-      {
-        delete[] m_layerIncludedInPartitionFlag[h][j][k];
-      }        
-    }
-    delete[] m_numPartitionsInSchemeMinus1[h];       
-  }
-  delete[] m_numSignalledPartitioningSchemes;
-}
-
-
-Int TComVpsVuiBspHrdParameters::getBspHrdIdxLen(TComVPS* vps)
+}
+
+Int TComVpsVuiBspHrdParameters::getBspHrdIdxLen( const TComVPS* vps) const
 {
   return gCeilLog2( vps->getNumHrdParameters() + getVpsNumAddHrdParams() );
 }
 
-Void TComVpsVuiBspHrdParameters::createAfterVpsNumAddHrdParams( TComVPS* vps )
-{
-  assert( vps == NULL ); 
-  m_vps = vps; 
+Void TComVpsVuiBspHrdParameters::createAfterVpsNumAddHrdParams( const TComVPS* vps )
+{
   m_offsetHrdParamIdx = vps->getNumHrdParameters(); 
   m_numHrdParam       = vps->getNumHrdParameters() + getVpsNumAddHrdParams() - m_offsetHrdParamIdx;
   m_numOls            = vps->getNumOutputLayerSets(); 
 
-  m_cprmsAddPresentFlag   = new Bool    [ m_numHrdParam ];
-  m_numSubLayerHrdMinus1  = new Int     [ m_numHrdParam ];
-  m_hrdParameters         = new TComHRD [ m_numHrdParam ];
-
-  m_numSignalledPartitioningSchemes = new Int    [ m_numOls ]; 
-  m_numPartitionsInSchemeMinus1     = new Int*   [ m_numOls ];
-  m_numBspSchedulesMinus1           = new Int**  [ m_numOls ]; 
-  m_bspHrdIdx                       = new Int****[ m_numOls ];
-  m_bspSchedIdx                     = new Int****[ m_numOls ];
-}
-
-Void TComVpsVuiBspHrdParameters::createAfterNumSignalledPartitioningSchemes( Int h )
-{
-  m_numPartitionsInSchemeMinus1 [h]    = new Int    [ getNumSignalledPartitioningSchemes(h) ];
-  m_layerIncludedInPartitionFlag[h]    = new Bool** [ getNumSignalledPartitioningSchemes(h) ];    
-
-  m_numBspSchedulesMinus1[h]           = new Int*   [ getNumSignalledPartitioningSchemes(h) + 1 ];
+  m_cprmsAddPresentFlag .resize( m_numHrdParam );
+  m_numSubLayerHrdMinus1.resize( m_numHrdParam );
+  m_hrdParameters       .resize( m_numHrdParam );
+
+  m_numSignalledPartitioningSchemes .resize( m_numOls ); 
+  m_numPartitionsInSchemeMinus1     .resize( m_numOls );
+  m_numBspSchedulesMinus1           .resize( m_numOls ); 
+  m_bspHrdIdx                       .resize( m_numOls );
+  m_bspSchedIdx                     .resize( m_numOls );
+}
+
+Void TComVpsVuiBspHrdParameters::createAfterNumSignalledPartitioningSchemes( const TComVPS* vps, Int h )
+{
+  m_numPartitionsInSchemeMinus1 [h].resize( getNumSignalledPartitioningSchemes(h) );
+  m_layerIncludedInPartitionFlag[h].resize( getNumSignalledPartitioningSchemes(h) );    
+
+  m_numBspSchedulesMinus1       [h].resize( getNumSignalledPartitioningSchemes(h) + 1 );
   for (Int i = 0; i < getNumSignalledPartitioningSchemes(h) + 1; i++)
   {
-    Int tMax = m_vps->getMaxSubLayersInLayerSetMinus1( m_vps->olsIdxToLsIdx(h) ) + 1;
-    m_numBspSchedulesMinus1[h][i] = new Int  [ tMax ];
-    m_bspHrdIdx            [h][i] = new Int**[ tMax ];
-    m_bspSchedIdx          [h][i] = new Int**[ tMax ];
-  }
-}
-
-Void TComVpsVuiBspHrdParameters::createAfterNumPartitionsInSchemeMinus1( Int h, Int j )
-{
-  m_layerIncludedInPartitionFlag[h][j] = new Bool*[ getNumPartitionsInSchemeMinus1(h,j)];
+    Int tMax = vps->getMaxSubLayersInLayerSetMinus1( m_vps->olsIdxToLsIdx(h) ) + 1;
+    m_numBspSchedulesMinus1[h][i].resize( tMax );
+    m_bspHrdIdx            [h][i].resize( tMax );
+    m_bspSchedIdx          [h][i].resize( tMax );
+  }
+}
+
+Void TComVpsVuiBspHrdParameters::createAfterNumPartitionsInSchemeMinus1( const TComVPS* vps, Int h, Int j )
+{
+  m_layerIncludedInPartitionFlag[h][j].resize( getNumPartitionsInSchemeMinus1(h,j));
   for( Int k = 0; k < getNumPartitionsInSchemeMinus1(h,j); k++ )
   {
-    m_layerIncludedInPartitionFlag[h][j][k] = new Bool[ m_vps->getNumLayersInIdList( m_vps->olsIdxToLsIdx(h))];
-  }
-}
-
-Void TComVpsVuiBspHrdParameters::createAfterNumBspSchedulesMinus1( Int h, Int i, Int t )
-{
-  m_bspSchedIdx[h][i][t] = new Int* [ getNumBspSchedulesMinus1( h, i, t ) + 1 ];
-  m_bspHrdIdx  [h][i][t] = new Int* [ getNumBspSchedulesMinus1( h, i, t ) + 1 ];
+    m_layerIncludedInPartitionFlag[h][j][k].resize( m_vps->getNumLayersInIdList( vps->olsIdxToLsIdx(h)));
+  }
+}
+
+Void TComVpsVuiBspHrdParameters::createAfterNumBspSchedulesMinus1( const TComVPS* vps, Int h, Int i, Int t )
+{
+  m_bspSchedIdx[h][i][t].resize( getNumBspSchedulesMinus1( h, i, t ) + 1 );
+  m_bspHrdIdx  [h][i][t].resize( getNumBspSchedulesMinus1( h, i, t ) + 1 );
   for( Int j = 0; j < getNumBspSchedulesMinus1( h, i, t ) + 1; j++ )
   {
-    m_bspSchedIdx[h][i][t][j] = new Int[ getNumPartitionsInSchemeMinus1( h, i ) ];
-    m_bspHrdIdx  [h][i][t][j] = new Int[ getNumPartitionsInSchemeMinus1( h, i ) ];
-  }
-}
-
-
-Void TComVUI::inferVideoSignalInfo( TComVPS* vps, Int layerIdCurr )
+    m_bspSchedIdx[h][i][t][j].resize( getNumPartitionsInSchemeMinus1( h, i ) );
+    m_bspHrdIdx  [h][i][t][j].resize( getNumPartitionsInSchemeMinus1( h, i ) );
+  }
+}
+
+
+Void TComVUI::inferVideoSignalInfo( const TComVPS* vps, Int layerIdCurr )
 {
   if ( layerIdCurr == 0 || !vps->getVpsVuiPresentFlag() ) 
@@ -4947,8 +4834,8 @@
   }
 
-  TComVPSVUI* vpsVUI = vps->getVPSVUI(); 
-  assert( vpsVUI != NULL );  
-
-  TComVideoSignalInfo* videoSignalInfo = vpsVUI->getVideoSignalInfo( vpsVUI->getVpsVideoSignalInfoIdx( vps->getLayerIdInVps( layerIdCurr ) ) ); 
+  const TComVPSVUI* vpsVui = vps->getVPSVUI(); 
+  assert( vpsVui != NULL );  
+
+  const TComVideoSignalInfo* videoSignalInfo = vpsVui->getVideoSignalInfo( vpsVui->getVpsVideoSignalInfoIdx( vps->getLayerIdInVps( layerIdCurr ) ) ); 
   assert( videoSignalInfo != NULL );
 
@@ -4960,18 +4847,33 @@
 }
 
-TComDpbSize::TComDpbSize()
-{
-  for (Int i = 0; i < MAX_VPS_OUTPUTLAYER_SETS; i++ )
+Void TComDpbSize::init( Int numOutputLayerSets, Int maxNumLayerIds, Int maxNumSubLayers )  
+{
+  m_subLayerFlagInfoPresentFlag.resize( numOutputLayerSets );
+  m_subLayerDpbInfoPresentFlag .resize( numOutputLayerSets );
+  m_maxVpsDecPicBufferingMinus1.resize( numOutputLayerSets ); 
+  m_maxVpsNumReorderPics       .resize( numOutputLayerSets );
+  m_maxVpsLatencyIncreasePlus1 .resize( numOutputLayerSets );
+
+  for (Int i = 0; i < numOutputLayerSets; i++ )
   {      
     m_subLayerFlagInfoPresentFlag[i]  = false;
 
-    for (Int j = 0; j < MAX_TLAYER; j++  )
+    m_subLayerDpbInfoPresentFlag [i].resize( maxNumSubLayers );
+    m_maxVpsDecPicBufferingMinus1[i].resize( maxNumLayerIds ); 
+    m_maxVpsNumReorderPics       [i].resize( maxNumSubLayers );
+    m_maxVpsLatencyIncreasePlus1 [i].resize( maxNumSubLayers );    
+
+    for (Int j = 0; j < maxNumSubLayers; j++  )
     {        
       m_subLayerDpbInfoPresentFlag [i][j] = ( j == 0) ;
       m_maxVpsNumReorderPics       [i][j] = 0;
       m_maxVpsLatencyIncreasePlus1 [i][j] = 0;
-
-      for (Int k = 0; k < MAX_NUM_LAYER_IDS; k++ )
-      {
+    }
+
+    for (Int k = 0; k < maxNumLayerIds; k++ )
+    {
+      m_maxVpsDecPicBufferingMinus1[i][k].resize( maxNumSubLayers );
+      for (Int j = 0; j < maxNumSubLayers; j++  )
+      {        
         m_maxVpsDecPicBufferingMinus1[i][k][j] = MIN_INT; 
       }
@@ -4992,3 +4894,2 @@
 }
 #endif
-
